# coding: utf-8

"""
    Robust Intelligence REST API

    API methods for Robust Intelligence. Users must authenticate using the `X-Firewall-Auth-Token` for all the firewall methods and `rime-api-key` for all other methods.  # noqa: E501

    OpenAPI spec version: 1.0
    Contact: dev@robustintelligence.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class GenerativefirewallPiiDetectionDetails(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'flagged_entities': 'list[PiiDetectionDetailsFlaggedEntity]',
        'sanitized_text': 'str'
    }

    attribute_map = {
        'flagged_entities': 'flaggedEntities',
        'sanitized_text': 'sanitizedText'
    }

    def __init__(self, flagged_entities=None, sanitized_text=None):  # noqa: E501
        """GenerativefirewallPiiDetectionDetails - a model defined in Swagger"""  # noqa: E501
        self._flagged_entities = None
        self._sanitized_text = None
        self.discriminator = None
        if flagged_entities is not None:
            self.flagged_entities = flagged_entities
        if sanitized_text is not None:
            self.sanitized_text = sanitized_text

    @property
    def flagged_entities(self):
        """Gets the flagged_entities of this GenerativefirewallPiiDetectionDetails.  # noqa: E501

        Flagged entities are the entities that were detected in the text(s).  # noqa: E501

        :return: The flagged_entities of this GenerativefirewallPiiDetectionDetails.  # noqa: E501
        :rtype: list[PiiDetectionDetailsFlaggedEntity]
        """
        return self._flagged_entities

    @flagged_entities.setter
    def flagged_entities(self, flagged_entities):
        """Sets the flagged_entities of this GenerativefirewallPiiDetectionDetails.

        Flagged entities are the entities that were detected in the text(s).  # noqa: E501

        :param flagged_entities: The flagged_entities of this GenerativefirewallPiiDetectionDetails.  # noqa: E501
        :type: list[PiiDetectionDetailsFlaggedEntity]
        """

        self._flagged_entities = flagged_entities

    @property
    def sanitized_text(self):
        """Gets the sanitized_text of this GenerativefirewallPiiDetectionDetails.  # noqa: E501

        Sanitized text is the original text with the flagged entities redacted.  # noqa: E501

        :return: The sanitized_text of this GenerativefirewallPiiDetectionDetails.  # noqa: E501
        :rtype: str
        """
        return self._sanitized_text

    @sanitized_text.setter
    def sanitized_text(self, sanitized_text):
        """Sets the sanitized_text of this GenerativefirewallPiiDetectionDetails.

        Sanitized text is the original text with the flagged entities redacted.  # noqa: E501

        :param sanitized_text: The sanitized_text of this GenerativefirewallPiiDetectionDetails.  # noqa: E501
        :type: str
        """

        self._sanitized_text = sanitized_text

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GenerativefirewallPiiDetectionDetails, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GenerativefirewallPiiDetectionDetails):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
