# coding: utf-8

"""
    Robust Intelligence REST API

    API methods for Robust Intelligence. Users must authenticate using the `X-Firewall-Auth-Token` for all the firewall methods and `rime-api-key` for all other methods.  # noqa: E501

    OpenAPI spec version: 1.0
    Contact: dev@robustintelligence.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class GenerativefirewallYaraVersionInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'git_ref': 'str',
        'latest_commit_hash': 'str'
    }

    attribute_map = {
        'git_ref': 'gitRef',
        'latest_commit_hash': 'latestCommitHash'
    }

    def __init__(self, git_ref=None, latest_commit_hash=None):  # noqa: E501
        """GenerativefirewallYaraVersionInfo - a model defined in Swagger"""  # noqa: E501
        self._git_ref = None
        self._latest_commit_hash = None
        self.discriminator = None
        if git_ref is not None:
            self.git_ref = git_ref
        if latest_commit_hash is not None:
            self.latest_commit_hash = latest_commit_hash

    @property
    def git_ref(self):
        """Gets the git_ref of this GenerativefirewallYaraVersionInfo.  # noqa: E501

        The git ref (release, commit, or branch) that the YARA server is configured to pull from.  # noqa: E501

        :return: The git_ref of this GenerativefirewallYaraVersionInfo.  # noqa: E501
        :rtype: str
        """
        return self._git_ref

    @git_ref.setter
    def git_ref(self, git_ref):
        """Sets the git_ref of this GenerativefirewallYaraVersionInfo.

        The git ref (release, commit, or branch) that the YARA server is configured to pull from.  # noqa: E501

        :param git_ref: The git_ref of this GenerativefirewallYaraVersionInfo.  # noqa: E501
        :type: str
        """

        self._git_ref = git_ref

    @property
    def latest_commit_hash(self):
        """Gets the latest_commit_hash of this GenerativefirewallYaraVersionInfo.  # noqa: E501

        The most recent commit on the specified git ref. Metadata for telemetry only.  # noqa: E501

        :return: The latest_commit_hash of this GenerativefirewallYaraVersionInfo.  # noqa: E501
        :rtype: str
        """
        return self._latest_commit_hash

    @latest_commit_hash.setter
    def latest_commit_hash(self, latest_commit_hash):
        """Sets the latest_commit_hash of this GenerativefirewallYaraVersionInfo.

        The most recent commit on the specified git ref. Metadata for telemetry only.  # noqa: E501

        :param latest_commit_hash: The latest_commit_hash of this GenerativefirewallYaraVersionInfo.  # noqa: E501
        :type: str
        """

        self._latest_commit_hash = latest_commit_hash

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GenerativefirewallYaraVersionInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GenerativefirewallYaraVersionInfo):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
