# coding: utf-8

"""
    Robust Intelligence REST API

    API methods for Robust Intelligence. Users must authenticate using the `X-Firewall-Auth-Token` for all the firewall methods and `rime-api-key` for all other methods.  # noqa: E501

    OpenAPI spec version: 1.0
    Contact: dev@robustintelligence.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class GenerativevalidationHttpConnectionSpec(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'url': 'str',
        'response_json_path': 'str',
        'body_template': 'object',
        'headers': 'dict(str, str)'
    }

    attribute_map = {
        'url': 'url',
        'response_json_path': 'responseJsonPath',
        'body_template': 'bodyTemplate',
        'headers': 'headers'
    }

    def __init__(self, url=None, response_json_path=None, body_template=None, headers=None):  # noqa: E501
        """GenerativevalidationHttpConnectionSpec - a model defined in Swagger"""  # noqa: E501
        self._url = None
        self._response_json_path = None
        self._body_template = None
        self._headers = None
        self.discriminator = None
        self.url = url
        self.response_json_path = response_json_path
        if body_template is not None:
            self.body_template = body_template
        if headers is not None:
            self.headers = headers

    @property
    def url(self):
        """Gets the url of this GenerativevalidationHttpConnectionSpec.  # noqa: E501


        :return: The url of this GenerativevalidationHttpConnectionSpec.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this GenerativevalidationHttpConnectionSpec.


        :param url: The url of this GenerativevalidationHttpConnectionSpec.  # noqa: E501
        :type: str
        """
        if url is None:
            raise ValueError("Invalid value for `url`, must not be `None`")  # noqa: E501

        self._url = url

    @property
    def response_json_path(self):
        """Gets the response_json_path of this GenerativevalidationHttpConnectionSpec.  # noqa: E501

        A json path specifying where in the response json payload we can find the LLM's response response string. Note that the path must point to a string value in the json payload. Whitespace and other special characters can be encoded as unicode (\\u0020). Periods in json fields can be escaped with a backslash.  # noqa: E501

        :return: The response_json_path of this GenerativevalidationHttpConnectionSpec.  # noqa: E501
        :rtype: str
        """
        return self._response_json_path

    @response_json_path.setter
    def response_json_path(self, response_json_path):
        """Sets the response_json_path of this GenerativevalidationHttpConnectionSpec.

        A json path specifying where in the response json payload we can find the LLM's response response string. Note that the path must point to a string value in the json payload. Whitespace and other special characters can be encoded as unicode (\\u0020). Periods in json fields can be escaped with a backslash.  # noqa: E501

        :param response_json_path: The response_json_path of this GenerativevalidationHttpConnectionSpec.  # noqa: E501
        :type: str
        """
        if response_json_path is None:
            raise ValueError("Invalid value for `response_json_path`, must not be `None`")  # noqa: E501

        self._response_json_path = response_json_path

    @property
    def body_template(self):
        """Gets the body_template of this GenerativevalidationHttpConnectionSpec.  # noqa: E501


        :return: The body_template of this GenerativevalidationHttpConnectionSpec.  # noqa: E501
        :rtype: object
        """
        return self._body_template

    @body_template.setter
    def body_template(self, body_template):
        """Sets the body_template of this GenerativevalidationHttpConnectionSpec.


        :param body_template: The body_template of this GenerativevalidationHttpConnectionSpec.  # noqa: E501
        :type: object
        """

        self._body_template = body_template

    @property
    def headers(self):
        """Gets the headers of this GenerativevalidationHttpConnectionSpec.  # noqa: E501

        Headers that will be sent along with the request payload to the LLM endpoint. These headers can include authentication.  # noqa: E501

        :return: The headers of this GenerativevalidationHttpConnectionSpec.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._headers

    @headers.setter
    def headers(self, headers):
        """Sets the headers of this GenerativevalidationHttpConnectionSpec.

        Headers that will be sent along with the request payload to the LLM endpoint. These headers can include authentication.  # noqa: E501

        :param headers: The headers of this GenerativevalidationHttpConnectionSpec.  # noqa: E501
        :type: dict(str, str)
        """

        self._headers = headers

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(GenerativevalidationHttpConnectionSpec, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GenerativevalidationHttpConnectionSpec):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
