# coding: utf-8

"""
    Robust Intelligence REST API

    API methods for Robust Intelligence. Users must authenticate using the `X-Firewall-Auth-Token` for all the firewall methods and `rime-api-key` for all other methods.  # noqa: E501

    OpenAPI spec version: 1.0
    Contact: dev@robustintelligence.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class InstancesHeartbeatBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'agent_id': 'object',
        'firewall_instance_heartbeats': 'list[RimeFirewallInstanceHeartbeat]'
    }

    attribute_map = {
        'agent_id': 'agentId',
        'firewall_instance_heartbeats': 'firewallInstanceHeartbeats'
    }

    def __init__(self, agent_id=None, firewall_instance_heartbeats=None):  # noqa: E501
        """InstancesHeartbeatBody - a model defined in Swagger"""  # noqa: E501
        self._agent_id = None
        self._firewall_instance_heartbeats = None
        self.discriminator = None
        if agent_id is not None:
            self.agent_id = agent_id
        if firewall_instance_heartbeats is not None:
            self.firewall_instance_heartbeats = firewall_instance_heartbeats

    @property
    def agent_id(self):
        """Gets the agent_id of this InstancesHeartbeatBody.  # noqa: E501

        The ID of the agent that hosts this firewall instance.  # noqa: E501

        :return: The agent_id of this InstancesHeartbeatBody.  # noqa: E501
        :rtype: object
        """
        return self._agent_id

    @agent_id.setter
    def agent_id(self, agent_id):
        """Sets the agent_id of this InstancesHeartbeatBody.

        The ID of the agent that hosts this firewall instance.  # noqa: E501

        :param agent_id: The agent_id of this InstancesHeartbeatBody.  # noqa: E501
        :type: object
        """

        self._agent_id = agent_id

    @property
    def firewall_instance_heartbeats(self):
        """Gets the firewall_instance_heartbeats of this InstancesHeartbeatBody.  # noqa: E501

        The list ID of the firewall instance.  # noqa: E501

        :return: The firewall_instance_heartbeats of this InstancesHeartbeatBody.  # noqa: E501
        :rtype: list[RimeFirewallInstanceHeartbeat]
        """
        return self._firewall_instance_heartbeats

    @firewall_instance_heartbeats.setter
    def firewall_instance_heartbeats(self, firewall_instance_heartbeats):
        """Sets the firewall_instance_heartbeats of this InstancesHeartbeatBody.

        The list ID of the firewall instance.  # noqa: E501

        :param firewall_instance_heartbeats: The firewall_instance_heartbeats of this InstancesHeartbeatBody.  # noqa: E501
        :type: list[RimeFirewallInstanceHeartbeat]
        """

        self._firewall_instance_heartbeats = firewall_instance_heartbeats

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(InstancesHeartbeatBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InstancesHeartbeatBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
