# coding: utf-8

"""
    Robust Intelligence REST API

    API methods for Robust Intelligence. Users must authenticate using the `X-Firewall-Auth-Token` for all the firewall methods and `rime-api-key` for all other methods.  # noqa: E501

    OpenAPI spec version: 1.0
    Contact: dev@robustintelligence.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class RimeRegisterFirewallAgentRequest(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'base_request': 'RimeRegisterExternalAgentRequest',
        'url': 'str',
        'register_version': 'str'
    }

    attribute_map = {
        'base_request': 'baseRequest',
        'url': 'url',
        'register_version': 'registerVersion'
    }

    def __init__(self, base_request=None, url=None, register_version=None):  # noqa: E501
        """RimeRegisterFirewallAgentRequest - a model defined in Swagger"""  # noqa: E501
        self._base_request = None
        self._url = None
        self._register_version = None
        self.discriminator = None
        if base_request is not None:
            self.base_request = base_request
        if url is not None:
            self.url = url
        if register_version is not None:
            self.register_version = register_version

    @property
    def base_request(self):
        """Gets the base_request of this RimeRegisterFirewallAgentRequest.  # noqa: E501


        :return: The base_request of this RimeRegisterFirewallAgentRequest.  # noqa: E501
        :rtype: RimeRegisterExternalAgentRequest
        """
        return self._base_request

    @base_request.setter
    def base_request(self, base_request):
        """Sets the base_request of this RimeRegisterFirewallAgentRequest.


        :param base_request: The base_request of this RimeRegisterFirewallAgentRequest.  # noqa: E501
        :type: RimeRegisterExternalAgentRequest
        """

        self._base_request = base_request

    @property
    def url(self):
        """Gets the url of this RimeRegisterFirewallAgentRequest.  # noqa: E501

        The URL of the agent. E.g., https://dev.my-firewall.rbst.io This is used for firewall agents, which can have a different URL than the control plane.  # noqa: E501

        :return: The url of this RimeRegisterFirewallAgentRequest.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this RimeRegisterFirewallAgentRequest.

        The URL of the agent. E.g., https://dev.my-firewall.rbst.io This is used for firewall agents, which can have a different URL than the control plane.  # noqa: E501

        :param url: The url of this RimeRegisterFirewallAgentRequest.  # noqa: E501
        :type: str
        """

        self._url = url

    @property
    def register_version(self):
        """Gets the register_version of this RimeRegisterFirewallAgentRequest.  # noqa: E501


        :return: The register_version of this RimeRegisterFirewallAgentRequest.  # noqa: E501
        :rtype: str
        """
        return self._register_version

    @register_version.setter
    def register_version(self, register_version):
        """Sets the register_version of this RimeRegisterFirewallAgentRequest.


        :param register_version: The register_version of this RimeRegisterFirewallAgentRequest.  # noqa: E501
        :type: str
        """

        self._register_version = register_version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RimeRegisterFirewallAgentRequest, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RimeRegisterFirewallAgentRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
