# coding: utf-8

"""
    Robust Intelligence REST API

    API methods for Robust Intelligence. Users must authenticate using the `X-Firewall-Auth-Token` for all the firewall methods and `rime-api-key` for all other methods.  # noqa: E501

    OpenAPI spec version: 1.0
    Contact: dev@robustintelligence.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class WorkspaceIdUuidUsersBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'workspace_id': 'object',
        'users': 'list[RimeUserWithRole]'
    }

    attribute_map = {
        'workspace_id': 'workspaceId',
        'users': 'users'
    }

    def __init__(self, workspace_id=None, users=None):  # noqa: E501
        """WorkspaceIdUuidUsersBody - a model defined in Swagger"""  # noqa: E501
        self._workspace_id = None
        self._users = None
        self.discriminator = None
        if workspace_id is not None:
            self.workspace_id = workspace_id
        self.users = users

    @property
    def workspace_id(self):
        """Gets the workspace_id of this WorkspaceIdUuidUsersBody.  # noqa: E501

        Unique ID of an object in RIME.  # noqa: E501

        :return: The workspace_id of this WorkspaceIdUuidUsersBody.  # noqa: E501
        :rtype: object
        """
        return self._workspace_id

    @workspace_id.setter
    def workspace_id(self, workspace_id):
        """Sets the workspace_id of this WorkspaceIdUuidUsersBody.

        Unique ID of an object in RIME.  # noqa: E501

        :param workspace_id: The workspace_id of this WorkspaceIdUuidUsersBody.  # noqa: E501
        :type: object
        """

        self._workspace_id = workspace_id

    @property
    def users(self):
        """Gets the users of this WorkspaceIdUuidUsersBody.  # noqa: E501

        List of Users to add to the Workspace.  # noqa: E501

        :return: The users of this WorkspaceIdUuidUsersBody.  # noqa: E501
        :rtype: list[RimeUserWithRole]
        """
        return self._users

    @users.setter
    def users(self, users):
        """Sets the users of this WorkspaceIdUuidUsersBody.

        List of Users to add to the Workspace.  # noqa: E501

        :param users: The users of this WorkspaceIdUuidUsersBody.  # noqa: E501
        :type: list[RimeUserWithRole]
        """
        if users is None:
            raise ValueError("Invalid value for `users`, must not be `None`")  # noqa: E501

        self._users = users

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(WorkspaceIdUuidUsersBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, WorkspaceIdUuidUsersBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
